clear all
close all
%Hybrid controller
%% System specifications
Rm = 1;
Lm = 10e-03;
J1 = 0.01213;
J2 = 0.01213;
B1 = 0.1;
B2 = 0.1;
M = 0.5;
Ki = 1e-03;
Kv = 0.45;
K1 = 1e-03;
K2 = 1e-03;
r1 = 0.1;
r2 = 0.1;
%% The Error State Space
alpha1 = -(K1+(r1/r2)^2*(K2))/(J1+(r1/r2)^2*(J2+0.5*M*r2^2));
alpha2 = -((B1+(r1/r2)^2*(B2)))/(J1+(r1/r2)^2*(J2+0.5*M*r2^2));
alpha3 = Ki/(J1+(r1/r2)^2*(J2+0.5*M*r2^2));
beta2 = -Kv/Lm;
beta3 = -Rm/Lm;
A = [0 1 0;
    alpha1 alpha2 alpha3;
    0 beta2 beta3];
B = [0 0 1/Lm]';
C = [1 0 0];
%% Observer-Controller Parameters
Bp = [0 0 1];
M = [1 1 1]';
N = 0.01;
K_obs = place(A',C',[-35,-40,-100])';
%% Simulation
sim('Hybrid_control_system');
save('Hybrid_control_system.mat','t_hyb','u_hyb','X_hyb','xd_hyb');